> ## Documentation Index
> Fetch the complete documentation index at: https://docs.apostra.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get products across storefronts

> Send a canonical AdCP get_products request across selected or all connected storefronts. Omit ext.interchange.screening for unscreened retrieval or provide buyer instructions for managed proposal accept, reject, and refine screening. Provisional responses are replacement snapshots; terminal cursors reference the frozen result.



## OpenAPI

````yaml /v2/buyer-api-v2.yaml post /products/query
openapi: 3.0.0
info:
  title: Scope3 Buyer API
  version: 2.0.0
  description: |-
    REST API for advertisers to manage advertisers, campaigns, and reporting.

    ## Authentication

    All endpoints require a Bearer token in the Authorization header:
    ```
    Authorization: Bearer your-api-key
    ```

    ## Base URL

    `https://api.interchange.io/api/v2/buyer`

    ## For AI Agents

    AI agents can use the MCP endpoint at `/mcp/v2/buyer` with three tools:
    - `initialize`: Start an MCP session
    - `api_call`: Make REST API calls
    - `ask_about_capability`: Learn about API features
servers:
  - url: https://api.interchange.io/api/v2/buyer
    description: Production server
security: []
tags:
  - name: Signup
    description: Request reviewed access to Interchange
  - name: Account
    description: Account management, service tokens, and preferences
  - name: Asks
    description: >-
      What you are waiting on Scope3 for — support, product, and supply asks in
      one list
  - name: Advertisers
    description: Manage advertisers
  - name: Product Discovery
    description: Discover and select products
  - name: Campaigns
    description: Manage advertising campaigns
  - name: Creatives
    description: Build, manage, and sync campaign creatives via AdCP Creative Protocol
  - name: Reporting
    description: Access performance metrics
  - name: Event Sources
    description: >-
      Manage event source configurations and log conversion/marketing events for
      attribution
  - name: Property Lists
    description: Validate property lists against AAO registry
  - name: Sales Agents
    description: View and connect sales agents
  - name: Measurement
    description: Measurement sources, records, context, and freshness
  - name: Syndication
    description: Syndicate resources to ADCP agents
  - name: Tasks
    description: Track async operation status
  - name: Buyer Billing
    description: >-
      Consolidated invoicing for buyers — invoices and pending invoice items
      issued by Scope3 across the buyer customer.
  - name: MCP
    description: Model Context Protocol endpoints for AI agents
paths:
  /products/query:
    post:
      tags:
        - Product Discovery
      summary: Get products across storefronts
      description: >-
        Send a canonical AdCP get_products request across selected or all
        connected storefronts. Omit ext.interchange.screening for unscreened
        retrieval or provide buyer instructions for managed proposal accept,
        reject, and refine screening. Provisional responses are replacement
        snapshots; terminal cursors reference the frozen result.
      operationId: getMarketplaceProducts
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GetProductsBody'
      responses:
        '200':
          description: Get products across storefronts
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectedGetProductsResponse'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      security:
        - bearerAuth: []
components:
  schemas:
    GetProductsBody:
      type: object
      properties:
        adcp_version:
          type: string
          pattern: >-
            ^(?:0|[1-9]\d*)\.(?:0|[1-9]\d*)(?:-[a-zA-Z0-9](?:[a-zA-Z0-9.-]*[a-zA-Z0-9])?)?$
        adcp_major_version:
          type: integer
          minimum: 1
          maximum: 99
        idempotency_key:
          type: string
          minLength: 16
          maxLength: 255
          pattern: ^[A-Za-z0-9_.:-]{16,255}$
        buying_mode:
          anyOf:
            - type: string
              enum:
                - brief
            - type: string
              enum:
                - wholesale
            - type: string
              enum:
                - refine
        brief:
          type: string
        refine:
          type: array
          items:
            anyOf:
              - type: object
                properties:
                  scope:
                    type: string
                    enum:
                      - request
                  ask:
                    type: string
                    minLength: 1
                required:
                  - scope
                  - ask
                additionalProperties: {}
              - type: object
                properties:
                  scope:
                    type: string
                    enum:
                      - product
                  product_id:
                    type: string
                    minLength: 1
                  action:
                    anyOf:
                      - type: string
                        enum:
                          - include
                      - type: string
                        enum:
                          - omit
                      - type: string
                        enum:
                          - more_like_this
                  ask:
                    type: string
                    minLength: 1
                required:
                  - scope
                  - product_id
                additionalProperties: {}
              - type: object
                properties:
                  scope:
                    type: string
                    enum:
                      - proposal
                  proposal_id:
                    type: string
                    minLength: 1
                  action:
                    anyOf:
                      - type: string
                        enum:
                          - include
                      - type: string
                        enum:
                          - omit
                      - type: string
                        enum:
                          - finalize
                  ask:
                    type: string
                    minLength: 1
                required:
                  - scope
                  - proposal_id
                additionalProperties: {}
        brand:
          type: object
          properties:
            domain:
              type: string
              pattern: >-
                ^[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$
            brand_id:
              type: string
              pattern: ^[a-z0-9_]+$
            countries:
              type: array
              items:
                type: string
            industries:
              type: array
              items:
                type: string
            data_subject_contestation:
              type: object
              properties:
                url:
                  type: string
                  pattern: ^https:\/\/
                email:
                  type: string
                  format: email
                  pattern: >-
                    ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
                languages:
                  type: array
                  items:
                    type: string
              additionalProperties: {}
            brand_kit_override:
              type: object
              properties:
                logo:
                  type: object
                  properties:
                    asset_type:
                      type: string
                      enum:
                        - image
                    url:
                      type: string
                    width:
                      type: integer
                      minimum: 1
                      maximum: 9007199254740991
                    height:
                      type: integer
                      minimum: 1
                      maximum: 9007199254740991
                    file_size_bytes:
                      type: integer
                      minimum: 1
                      maximum: 9007199254740991
                    pixel_ratio:
                      type: number
                      minimum: 0
                      exclusiveMinimum: true
                    state_id:
                      type: string
                    breakpoint_id:
                      type: string
                    focal_point:
                      type: array
                      items:
                        anyOf:
                          - type: number
                          - type: number
                      minItems: 2
                      maxItems: 2
                    format:
                      type: string
                    alt_text:
                      type: string
                    provenance:
                      type: object
                      properties:
                        digital_source_type:
                          anyOf:
                            - type: string
                              enum:
                                - digital_capture
                            - type: string
                              enum:
                                - digital_creation
                            - type: string
                              enum:
                                - trained_algorithmic_media
                            - type: string
                              enum:
                                - composite_with_trained_algorithmic_media
                            - type: string
                              enum:
                                - algorithmic_media
                            - type: string
                              enum:
                                - composite_capture
                            - type: string
                              enum:
                                - composite_synthetic
                            - type: string
                              enum:
                                - human_edits
                            - type: string
                              enum:
                                - data_driven_media
                        synthetic_depiction:
                          type: boolean
                        ai_tool:
                          type: object
                          properties:
                            name:
                              type: string
                            version:
                              type: string
                            provider:
                              type: string
                          required:
                            - name
                          additionalProperties: {}
                        human_oversight:
                          anyOf:
                            - type: string
                              enum:
                                - none
                            - type: string
                              enum:
                                - prompt_only
                            - type: string
                              enum:
                                - selected
                            - type: string
                              enum:
                                - edited
                            - type: string
                              enum:
                                - directed
                        declared_by:
                          type: object
                          properties:
                            agent_url:
                              type: string
                            role:
                              anyOf:
                                - type: string
                                  enum:
                                    - creator
                                - type: string
                                  enum:
                                    - advertiser
                                - type: string
                                  enum:
                                    - agency
                                - type: string
                                  enum:
                                    - platform
                                - type: string
                                  enum:
                                    - tool
                          required:
                            - role
                          additionalProperties: {}
                        declared_at:
                          type: string
                        created_time:
                          type: string
                        c2pa:
                          type: object
                          properties:
                            manifest_url:
                              type: string
                          required:
                            - manifest_url
                          additionalProperties: {}
                        embedded_provenance:
                          type: array
                          items:
                            type: object
                            properties:
                              method:
                                anyOf:
                                  - type: string
                                    enum:
                                      - manifest_wrapper
                                  - type: string
                                    enum:
                                      - provenance_markers
                              standard:
                                type: string
                              provider:
                                type: string
                              verify_agent:
                                type: object
                                properties:
                                  agent_url:
                                    type: string
                                  feature_id:
                                    type: string
                                required:
                                  - agent_url
                                additionalProperties: {}
                              embedded_at:
                                type: string
                            required:
                              - method
                              - provider
                            additionalProperties: {}
                        watermarks:
                          type: array
                          items:
                            type: object
                            properties:
                              media_type:
                                anyOf:
                                  - type: string
                                    enum:
                                      - audio
                                  - type: string
                                    enum:
                                      - image
                                  - type: string
                                    enum:
                                      - video
                                  - type: string
                                    enum:
                                      - text
                              provider:
                                type: string
                              verify_agent:
                                type: object
                                properties:
                                  agent_url:
                                    type: string
                                  feature_id:
                                    type: string
                                required:
                                  - agent_url
                                additionalProperties: {}
                              c2pa_action:
                                anyOf:
                                  - type: string
                                    enum:
                                      - c2pa.watermarked.bound
                                  - type: string
                                    enum:
                                      - c2pa.watermarked.unbound
                              embedded_at:
                                type: string
                            required:
                              - media_type
                              - provider
                            additionalProperties: {}
                        disclosure:
                          type: object
                          properties:
                            required:
                              type: boolean
                            jurisdictions:
                              type: array
                              items:
                                type: object
                                properties:
                                  country:
                                    type: string
                                  region:
                                    type: string
                                  regulation:
                                    type: string
                                  label_text:
                                    type: string
                                  render_guidance:
                                    type: object
                                    properties:
                                      persistence:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - continuous
                                          - type: string
                                            enum:
                                              - initial
                                          - type: string
                                            enum:
                                              - flexible
                                      min_duration_ms:
                                        type: integer
                                        minimum: 1
                                        maximum: 9007199254740991
                                      positions:
                                        type: array
                                        items:
                                          anyOf:
                                            - type: string
                                              enum:
                                                - prominent
                                            - type: string
                                              enum:
                                                - footer
                                            - type: string
                                              enum:
                                                - audio
                                            - type: string
                                              enum:
                                                - subtitle
                                            - type: string
                                              enum:
                                                - overlay
                                            - type: string
                                              enum:
                                                - end_card
                                            - type: string
                                              enum:
                                                - pre_roll
                                            - type: string
                                              enum:
                                                - companion
                                      ext:
                                        type: object
                                        additionalProperties: {}
                                    additionalProperties: {}
                                required:
                                  - country
                                  - regulation
                                additionalProperties: {}
                          required:
                            - required
                          additionalProperties: {}
                        verification:
                          type: array
                          items:
                            type: object
                            properties:
                              verified_by:
                                type: string
                              verified_time:
                                type: string
                              result:
                                anyOf:
                                  - type: string
                                    enum:
                                      - authentic
                                  - type: string
                                    enum:
                                      - ai_generated
                                  - type: string
                                    enum:
                                      - ai_modified
                                  - type: string
                                    enum:
                                      - inconclusive
                              confidence:
                                type: number
                                minimum: 0
                                maximum: 1
                              details_url:
                                type: string
                            required:
                              - verified_by
                              - result
                            additionalProperties: {}
                        ext:
                          type: object
                          additionalProperties: {}
                      additionalProperties: {}
                  required:
                    - asset_type
                    - url
                    - width
                    - height
                  additionalProperties: {}
                colors:
                  type: object
                  properties:
                    primary:
                      type: string
                      pattern: ^#[0-9a-fA-F]{6}$
                    secondary:
                      type: string
                      pattern: ^#[0-9a-fA-F]{6}$
                    accent:
                      type: string
                      pattern: ^#[0-9a-fA-F]{6}$
                  additionalProperties: {}
                voice:
                  type: string
                tagline:
                  type: string
              additionalProperties: {}
          required:
            - domain
          additionalProperties: {}
        acceptance_context:
          type: object
          properties:
            subjects:
              type: array
              items:
                type: object
                properties:
                  subject_category:
                    type: string
                    pattern: ^[a-z][a-z0-9_]*$
                  subject_facets:
                    type: array
                    items:
                      type: string
                required:
                  - subject_category
                additionalProperties: {}
            advertiser_roles:
              type: array
              items:
                type: string
            advertiser_industry:
              anyOf:
                - type: string
                  enum:
                    - automotive
                - type: string
                  enum:
                    - automotive.electric_vehicles
                - type: string
                  enum:
                    - automotive.parts_accessories
                - type: string
                  enum:
                    - automotive.luxury
                - type: string
                  enum:
                    - beauty_cosmetics
                - type: string
                  enum:
                    - beauty_cosmetics.skincare
                - type: string
                  enum:
                    - beauty_cosmetics.fragrance
                - type: string
                  enum:
                    - beauty_cosmetics.haircare
                - type: string
                  enum:
                    - cannabis
                - type: string
                  enum:
                    - cpg
                - type: string
                  enum:
                    - cpg.personal_care
                - type: string
                  enum:
                    - cpg.household
                - type: string
                  enum:
                    - dating
                - type: string
                  enum:
                    - education
                - type: string
                  enum:
                    - education.higher_education
                - type: string
                  enum:
                    - education.online_learning
                - type: string
                  enum:
                    - education.k12
                - type: string
                  enum:
                    - energy_utilities
                - type: string
                  enum:
                    - energy_utilities.renewable
                - type: string
                  enum:
                    - fashion_apparel
                - type: string
                  enum:
                    - fashion_apparel.luxury
                - type: string
                  enum:
                    - fashion_apparel.sportswear
                - type: string
                  enum:
                    - finance
                - type: string
                  enum:
                    - finance.banking
                - type: string
                  enum:
                    - finance.insurance
                - type: string
                  enum:
                    - finance.investment
                - type: string
                  enum:
                    - finance.cryptocurrency
                - type: string
                  enum:
                    - food_beverage
                - type: string
                  enum:
                    - food_beverage.alcohol
                - type: string
                  enum:
                    - food_beverage.restaurants
                - type: string
                  enum:
                    - food_beverage.packaged_goods
                - type: string
                  enum:
                    - gambling_betting
                - type: string
                  enum:
                    - gambling_betting.sports_betting
                - type: string
                  enum:
                    - gambling_betting.casino
                - type: string
                  enum:
                    - gaming
                - type: string
                  enum:
                    - gaming.mobile
                - type: string
                  enum:
                    - gaming.console_pc
                - type: string
                  enum:
                    - gaming.esports
                - type: string
                  enum:
                    - government_nonprofit
                - type: string
                  enum:
                    - government_nonprofit.political
                - type: string
                  enum:
                    - government_nonprofit.charity
                - type: string
                  enum:
                    - healthcare
                - type: string
                  enum:
                    - healthcare.pharmaceutical
                - type: string
                  enum:
                    - healthcare.medical_devices
                - type: string
                  enum:
                    - healthcare.wellness
                - type: string
                  enum:
                    - home_garden
                - type: string
                  enum:
                    - home_garden.furniture
                - type: string
                  enum:
                    - home_garden.home_improvement
                - type: string
                  enum:
                    - media_entertainment
                - type: string
                  enum:
                    - media_entertainment.podcasts
                - type: string
                  enum:
                    - media_entertainment.music
                - type: string
                  enum:
                    - media_entertainment.film_tv
                - type: string
                  enum:
                    - media_entertainment.publishing
                - type: string
                  enum:
                    - media_entertainment.live_events
                - type: string
                  enum:
                    - pets
                - type: string
                  enum:
                    - professional_services
                - type: string
                  enum:
                    - professional_services.legal
                - type: string
                  enum:
                    - professional_services.consulting
                - type: string
                  enum:
                    - real_estate
                - type: string
                  enum:
                    - real_estate.residential
                - type: string
                  enum:
                    - real_estate.commercial
                - type: string
                  enum:
                    - recruitment_hr
                - type: string
                  enum:
                    - retail
                - type: string
                  enum:
                    - retail.ecommerce
                - type: string
                  enum:
                    - retail.department_stores
                - type: string
                  enum:
                    - sports_fitness
                - type: string
                  enum:
                    - sports_fitness.equipment
                - type: string
                  enum:
                    - sports_fitness.teams_leagues
                - type: string
                  enum:
                    - technology
                - type: string
                  enum:
                    - technology.software
                - type: string
                  enum:
                    - technology.hardware
                - type: string
                  enum:
                    - technology.ai_ml
                - type: string
                  enum:
                    - telecom
                - type: string
                  enum:
                    - telecom.mobile_carriers
                - type: string
                  enum:
                    - telecom.internet_providers
                - type: string
                  enum:
                    - transportation_logistics
                - type: string
                  enum:
                    - travel_hospitality
                - type: string
                  enum:
                    - travel_hospitality.airlines
                - type: string
                  enum:
                    - travel_hospitality.hotels
                - type: string
                  enum:
                    - travel_hospitality.cruise
                - type: string
                  enum:
                    - travel_hospitality.tourism
            advertiser_jurisdictions:
              type: array
              items:
                type: string
            delivery_jurisdictions:
              type: array
              items:
                type: string
            ext:
              type: object
              additionalProperties: {}
          additionalProperties: {}
        catalog:
          type: object
          properties:
            catalog_id:
              type: string
            name:
              type: string
            type:
              anyOf:
                - type: string
                  enum:
                    - offering
                - type: string
                  enum:
                    - product
                - type: string
                  enum:
                    - inventory
                - type: string
                  enum:
                    - store
                - type: string
                  enum:
                    - promotion
                - type: string
                  enum:
                    - hotel
                - type: string
                  enum:
                    - flight
                - type: string
                  enum:
                    - job
                - type: string
                  enum:
                    - vehicle
                - type: string
                  enum:
                    - real_estate
                - type: string
                  enum:
                    - education
                - type: string
                  enum:
                    - destination
                - type: string
                  enum:
                    - app
            url:
              type: string
            feed_format:
              anyOf:
                - type: string
                  enum:
                    - google_merchant_center
                - type: string
                  enum:
                    - facebook_catalog
                - type: string
                  enum:
                    - shopify
                - type: string
                  enum:
                    - linkedin_jobs
                - type: string
                  enum:
                    - tiktok_shop
                - type: string
                  enum:
                    - pinterest_catalog
                - type: string
                  enum:
                    - openai_product_feed
                - type: string
                  enum:
                    - custom
            update_frequency:
              anyOf:
                - type: string
                  enum:
                    - realtime
                - type: string
                  enum:
                    - hourly
                - type: string
                  enum:
                    - daily
                - type: string
                  enum:
                    - weekly
            items:
              type: array
              items:
                type: object
                properties: {}
                additionalProperties: {}
            ids:
              type: array
              items:
                type: string
            gtins:
              type: array
              items:
                type: string
            tags:
              type: array
              items:
                type: string
            category:
              type: string
            query:
              type: string
            conversion_events:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - page_view
                  - type: string
                    enum:
                      - view_content
                  - type: string
                    enum:
                      - select_content
                  - type: string
                    enum:
                      - select_item
                  - type: string
                    enum:
                      - search
                  - type: string
                    enum:
                      - share
                  - type: string
                    enum:
                      - add_to_cart
                  - type: string
                    enum:
                      - remove_from_cart
                  - type: string
                    enum:
                      - viewed_cart
                  - type: string
                    enum:
                      - add_to_wishlist
                  - type: string
                    enum:
                      - initiate_checkout
                  - type: string
                    enum:
                      - add_payment_info
                  - type: string
                    enum:
                      - purchase
                  - type: string
                    enum:
                      - refund
                  - type: string
                    enum:
                      - lead
                  - type: string
                    enum:
                      - qualify_lead
                  - type: string
                    enum:
                      - close_convert_lead
                  - type: string
                    enum:
                      - disqualify_lead
                  - type: string
                    enum:
                      - complete_registration
                  - type: string
                    enum:
                      - subscribe
                  - type: string
                    enum:
                      - follow
                  - type: string
                    enum:
                      - content_view
                  - type: string
                    enum:
                      - watch_milestone
                  - type: string
                    enum:
                      - start_trial
                  - type: string
                    enum:
                      - app_install
                  - type: string
                    enum:
                      - app_launch
                  - type: string
                    enum:
                      - contact
                  - type: string
                    enum:
                      - schedule
                  - type: string
                    enum:
                      - donate
                  - type: string
                    enum:
                      - submit_application
                  - type: string
                    enum:
                      - custom
            content_id_type:
              anyOf:
                - type: string
                  enum:
                    - sku
                - type: string
                  enum:
                    - gtin
                - type: string
                  enum:
                    - offering_id
                - type: string
                  enum:
                    - job_id
                - type: string
                  enum:
                    - hotel_id
                - type: string
                  enum:
                    - flight_id
                - type: string
                  enum:
                    - vehicle_id
                - type: string
                  enum:
                    - listing_id
                - type: string
                  enum:
                    - store_id
                - type: string
                  enum:
                    - program_id
                - type: string
                  enum:
                    - destination_id
                - type: string
                  enum:
                    - app_id
            feed_field_mappings:
              type: array
              items:
                type: object
                properties:
                  feed_field:
                    type: string
                  catalog_field:
                    type: string
                  asset_group_id:
                    type: string
                  value:
                    type: object
                    properties: {}
                    additionalProperties: {}
                  transform:
                    anyOf:
                      - type: string
                        enum:
                          - date
                      - type: string
                        enum:
                          - divide
                      - type: string
                        enum:
                          - boolean
                      - type: string
                        enum:
                          - split
                  format:
                    type: string
                  timezone:
                    type: string
                  by:
                    type: number
                    minimum: 0
                    exclusiveMinimum: true
                  separator:
                    type: string
                  default:
                    type: object
                    properties: {}
                    additionalProperties: {}
                  ext:
                    type: object
                    additionalProperties: {}
                additionalProperties: {}
          required:
            - type
          additionalProperties: {}
        account:
          anyOf:
            - type: object
              properties:
                account_id:
                  type: string
              required:
                - account_id
              additionalProperties: {}
            - type: object
              properties:
                brand:
                  type: object
                  properties:
                    domain:
                      type: string
                      pattern: >-
                        ^[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$
                    brand_id:
                      type: string
                      pattern: ^[a-z0-9_]+$
                    countries:
                      type: array
                      items:
                        type: string
                    industries:
                      type: array
                      items:
                        type: string
                    data_subject_contestation:
                      type: object
                      properties:
                        url:
                          type: string
                          pattern: ^https:\/\/
                        email:
                          type: string
                          format: email
                          pattern: >-
                            ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
                        languages:
                          type: array
                          items:
                            type: string
                      additionalProperties: {}
                    brand_kit_override:
                      type: object
                      properties:
                        logo:
                          type: object
                          properties:
                            asset_type:
                              type: string
                              enum:
                                - image
                            url:
                              type: string
                            width:
                              type: integer
                              minimum: 1
                              maximum: 9007199254740991
                            height:
                              type: integer
                              minimum: 1
                              maximum: 9007199254740991
                            file_size_bytes:
                              type: integer
                              minimum: 1
                              maximum: 9007199254740991
                            pixel_ratio:
                              type: number
                              minimum: 0
                              exclusiveMinimum: true
                            state_id:
                              type: string
                            breakpoint_id:
                              type: string
                            focal_point:
                              type: array
                              items:
                                anyOf:
                                  - type: number
                                  - type: number
                              minItems: 2
                              maxItems: 2
                            format:
                              type: string
                            alt_text:
                              type: string
                            provenance:
                              type: object
                              properties:
                                digital_source_type:
                                  anyOf:
                                    - type: string
                                      enum:
                                        - digital_capture
                                    - type: string
                                      enum:
                                        - digital_creation
                                    - type: string
                                      enum:
                                        - trained_algorithmic_media
                                    - type: string
                                      enum:
                                        - composite_with_trained_algorithmic_media
                                    - type: string
                                      enum:
                                        - algorithmic_media
                                    - type: string
                                      enum:
                                        - composite_capture
                                    - type: string
                                      enum:
                                        - composite_synthetic
                                    - type: string
                                      enum:
                                        - human_edits
                                    - type: string
                                      enum:
                                        - data_driven_media
                                synthetic_depiction:
                                  type: boolean
                                ai_tool:
                                  type: object
                                  properties:
                                    name:
                                      type: string
                                    version:
                                      type: string
                                    provider:
                                      type: string
                                  required:
                                    - name
                                  additionalProperties: {}
                                human_oversight:
                                  anyOf:
                                    - type: string
                                      enum:
                                        - none
                                    - type: string
                                      enum:
                                        - prompt_only
                                    - type: string
                                      enum:
                                        - selected
                                    - type: string
                                      enum:
                                        - edited
                                    - type: string
                                      enum:
                                        - directed
                                declared_by:
                                  type: object
                                  properties:
                                    agent_url:
                                      type: string
                                    role:
                                      anyOf:
                                        - type: string
                                          enum:
                                            - creator
                                        - type: string
                                          enum:
                                            - advertiser
                                        - type: string
                                          enum:
                                            - agency
                                        - type: string
                                          enum:
                                            - platform
                                        - type: string
                                          enum:
                                            - tool
                                  required:
                                    - role
                                  additionalProperties: {}
                                declared_at:
                                  type: string
                                created_time:
                                  type: string
                                c2pa:
                                  type: object
                                  properties:
                                    manifest_url:
                                      type: string
                                  required:
                                    - manifest_url
                                  additionalProperties: {}
                                embedded_provenance:
                                  type: array
                                  items:
                                    type: object
                                    properties:
                                      method:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - manifest_wrapper
                                          - type: string
                                            enum:
                                              - provenance_markers
                                      standard:
                                        type: string
                                      provider:
                                        type: string
                                      verify_agent:
                                        type: object
                                        properties:
                                          agent_url:
                                            type: string
                                          feature_id:
                                            type: string
                                        required:
                                          - agent_url
                                        additionalProperties: {}
                                      embedded_at:
                                        type: string
                                    required:
                                      - method
                                      - provider
                                    additionalProperties: {}
                                watermarks:
                                  type: array
                                  items:
                                    type: object
                                    properties:
                                      media_type:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - audio
                                          - type: string
                                            enum:
                                              - image
                                          - type: string
                                            enum:
                                              - video
                                          - type: string
                                            enum:
                                              - text
                                      provider:
                                        type: string
                                      verify_agent:
                                        type: object
                                        properties:
                                          agent_url:
                                            type: string
                                          feature_id:
                                            type: string
                                        required:
                                          - agent_url
                                        additionalProperties: {}
                                      c2pa_action:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - c2pa.watermarked.bound
                                          - type: string
                                            enum:
                                              - c2pa.watermarked.unbound
                                      embedded_at:
                                        type: string
                                    required:
                                      - media_type
                                      - provider
                                    additionalProperties: {}
                                disclosure:
                                  type: object
                                  properties:
                                    required:
                                      type: boolean
                                    jurisdictions:
                                      type: array
                                      items:
                                        type: object
                                        properties:
                                          country:
                                            type: string
                                          region:
                                            type: string
                                          regulation:
                                            type: string
                                          label_text:
                                            type: string
                                          render_guidance:
                                            type: object
                                            properties:
                                              persistence:
                                                anyOf:
                                                  - type: string
                                                    enum:
                                                      - continuous
                                                  - type: string
                                                    enum:
                                                      - initial
                                                  - type: string
                                                    enum:
                                                      - flexible
                                              min_duration_ms:
                                                type: integer
                                                minimum: 1
                                                maximum: 9007199254740991
                                              positions:
                                                type: array
                                                items:
                                                  anyOf:
                                                    - type: string
                                                      enum:
                                                        - prominent
                                                    - type: string
                                                      enum:
                                                        - footer
                                                    - type: string
                                                      enum:
                                                        - audio
                                                    - type: string
                                                      enum:
                                                        - subtitle
                                                    - type: string
                                                      enum:
                                                        - overlay
                                                    - type: string
                                                      enum:
                                                        - end_card
                                                    - type: string
                                                      enum:
                                                        - pre_roll
                                                    - type: string
                                                      enum:
                                                        - companion
                                              ext:
                                                type: object
                                                additionalProperties: {}
                                            additionalProperties: {}
                                        required:
                                          - country
                                          - regulation
                                        additionalProperties: {}
                                  required:
                                    - required
                                  additionalProperties: {}
                                verification:
                                  type: array
                                  items:
                                    type: object
                                    properties:
                                      verified_by:
                                        type: string
                                      verified_time:
                                        type: string
                                      result:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - authentic
                                          - type: string
                                            enum:
                                              - ai_generated
                                          - type: string
                                            enum:
                                              - ai_modified
                                          - type: string
                                            enum:
                                              - inconclusive
                                      confidence:
                                        type: number
                                        minimum: 0
                                        maximum: 1
                                      details_url:
                                        type: string
                                    required:
                                      - verified_by
                                      - result
                                    additionalProperties: {}
                                ext:
                                  type: object
                                  additionalProperties: {}
                              additionalProperties: {}
                          required:
                            - asset_type
                            - url
                            - width
                            - height
                          additionalProperties: {}
                        colors:
                          type: object
                          properties:
                            primary:
                              type: string
                              pattern: ^#[0-9a-fA-F]{6}$
                            secondary:
                              type: string
                              pattern: ^#[0-9a-fA-F]{6}$
                            accent:
                              type: string
                              pattern: ^#[0-9a-fA-F]{6}$
                          additionalProperties: {}
                        voice:
                          type: string
                        tagline:
                          type: string
                      additionalProperties: {}
                  required:
                    - domain
                  additionalProperties: {}
                operator:
                  type: string
                operator_unit:
                  type: object
                  properties:
                    id:
                      type: string
                      minLength: 1
                      maxLength: 255
                      pattern: ^[A-Za-z0-9][A-Za-z0-9._:/-]*$
                    name:
                      type: string
                      minLength: 1
                      maxLength: 200
                  required:
                    - id
                  additionalProperties: {}
                currency:
                  type: string
                timezone:
                  type: string
                sandbox:
                  type: boolean
              required:
                - brand
                - operator
              additionalProperties: {}
        preferred_delivery_types:
          type: array
          items:
            anyOf:
              - type: string
                enum:
                  - guaranteed
              - type: string
                enum:
                  - non_guaranteed
        filters:
          type: object
          properties:
            delivery_type:
              anyOf:
                - type: string
                  enum:
                    - guaranteed
                - type: string
                  enum:
                    - non_guaranteed
            exclusivity:
              anyOf:
                - type: string
                  enum:
                    - none
                - type: string
                  enum:
                    - category
                - type: string
                  enum:
                    - exclusive
            is_fixed_price:
              type: boolean
            pricing_structures:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - fixed
                  - type: string
                    enum:
                      - auction
                  - type: string
                    enum:
                      - contingent
            pricing_currencies:
              type: array
              items:
                type: string
            format_ids:
              type: array
              items:
                type: object
                properties:
                  agent_url:
                    type: string
                    allOf:
                      - type: string
                        pattern: ^[\x21-\x7E]+$
                      - type: string
                        pattern: ^(?:[^%]|%[0-9A-Fa-f]{2})*$
                  id:
                    type: string
                    pattern: ^[a-zA-Z0-9_-]+$
                  width:
                    type: integer
                    minimum: 1
                    maximum: 9007199254740991
                  height:
                    type: integer
                    minimum: 1
                    maximum: 9007199254740991
                  duration_ms:
                    type: number
                    minimum: 1
                  pixel_ratio:
                    type: number
                    minimum: 0
                    exclusiveMinimum: true
                required:
                  - agent_url
                  - id
                additionalProperties: {}
            format_kinds:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - image
                  - type: string
                    enum:
                      - html5
                  - type: string
                    enum:
                      - display_tag
                  - type: string
                    enum:
                      - image_carousel
                  - type: string
                    enum:
                      - video_hosted
                  - type: string
                    enum:
                      - video_vast
                  - type: string
                    enum:
                      - audio_hosted
                  - type: string
                    enum:
                      - audio_vast
                  - type: string
                    enum:
                      - audio_daast
                  - type: string
                    enum:
                      - sponsored_placement
                  - type: string
                    enum:
                      - native_in_feed
                  - type: string
                    enum:
                      - responsive_creative
                  - type: string
                    enum:
                      - agent_placement
                  - type: string
                    enum:
                      - seller_rendered_stateful_display
                  - type: string
                    enum:
                      - coordinated_placements
                  - type: string
                    enum:
                      - custom
            format_option_refs:
              type: array
              items:
                anyOf:
                  - type: object
                    properties:
                      scope:
                        type: string
                        enum:
                          - publisher
                      publisher_domain:
                        type: string
                      format_option_id:
                        type: string
                    required:
                      - scope
                      - publisher_domain
                      - format_option_id
                    additionalProperties: {}
                  - type: object
                    properties:
                      scope:
                        type: string
                        enum:
                          - product
                      format_option_id:
                        type: string
                      publisher_domain:
                        not: {}
                    required:
                      - scope
                      - format_option_id
                    additionalProperties: {}
            standard_formats_only:
              type: boolean
            min_exposures:
              type: integer
              minimum: 1
              maximum: 9007199254740991
            start_date:
              type: string
            end_date:
              type: string
            budget_range:
              type: object
              properties: {}
              additionalProperties: {}
            countries:
              type: array
              items:
                type: string
            regions:
              type: array
              items:
                type: string
            metros:
              type: array
              items:
                type: object
                properties:
                  system:
                    anyOf:
                      - type: string
                        enum:
                          - nielsen_dma
                      - type: string
                        enum:
                          - uk_itl1
                      - type: string
                        enum:
                          - uk_itl2
                      - type: string
                        enum:
                          - eurostat_nuts2
                      - type: string
                        enum:
                          - custom
                  code:
                    type: string
                required:
                  - system
                  - code
                additionalProperties: {}
            channels:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - display
                  - type: string
                    enum:
                      - olv
                  - type: string
                    enum:
                      - social
                  - type: string
                    enum:
                      - search
                  - type: string
                    enum:
                      - ctv
                  - type: string
                    enum:
                      - linear_tv
                  - type: string
                    enum:
                      - radio
                  - type: string
                    enum:
                      - streaming_audio
                  - type: string
                    enum:
                      - podcast
                  - type: string
                    enum:
                      - dooh
                  - type: string
                    enum:
                      - ooh
                  - type: string
                    enum:
                      - print
                  - type: string
                    enum:
                      - cinema
                  - type: string
                    enum:
                      - email
                  - type: string
                    enum:
                      - gaming
                  - type: string
                    enum:
                      - retail_media
                  - type: string
                    enum:
                      - influencer
                  - type: string
                    enum:
                      - affiliate
                  - type: string
                    enum:
                      - product_placement
                  - type: string
                    enum:
                      - sponsored_intelligence
            video_placement_types:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - instream
                  - type: string
                    enum:
                      - accompanying_content
                  - type: string
                    enum:
                      - interstitial
                  - type: string
                    enum:
                      - standalone
            audio_distribution_types:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - music_streaming_service
                  - type: string
                    enum:
                      - fm_am_broadcast
                  - type: string
                    enum:
                      - podcast
                  - type: string
                    enum:
                      - catch_up_radio
                  - type: string
                    enum:
                      - web_radio
                  - type: string
                    enum:
                      - video_game
                  - type: string
                    enum:
                      - text_to_speech
            sponsored_placement_types:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - sponsored_search
                  - type: string
                    enum:
                      - sponsored_display
                  - type: string
                    enum:
                      - sponsored_native
            social_placement_surfaces:
              type: array
              items:
                anyOf:
                  - type: string
                    enum:
                      - feed
                  - type: string
                    enum:
                      - stories
                  - type: string
                    enum:
                      - short_video
                  - type: string
                    enum:
                      - explore
                  - type: string
                    enum:
                      - search
            required_axe_integrations:
              type: array
              items:
                type: string
            trusted_match:
              type: object
              properties:
                providers:
                  type: array
                  items:
                    type: object
                    properties:
                      agent_url:
                        type: string
                      context_match:
                        type: boolean
                      identity_match:
                        type: boolean
                    required:
                      - agent_url
                    additionalProperties: {}
                response_types:
                  type: array
                  items:
                    anyOf:
                      - type: string
                        enum:
                          - activation
                      - type: string
                        enum:
                          - catalog_items
                      - type: string
                        enum:
                          - creative
                      - type: string
                        enum:
                          - deal
              additionalProperties: {}
            audience_activation_methods:
              type: array
              items:
                anyOf:
                  - type: object
                    properties:
                      pattern:
                        type: string
                        enum:
                          - sync_audiences
                    required:
                      - pattern
                    additionalProperties: {}
                  - type: object
                    properties:
                      pattern:
                        type: string
                        enum:
                          - tmp_identity_match
                      buyer_agent:
                        type: object
                        properties:
                          agent_url:
                            type: string
                        required:
                          - agent_url
                        additionalProperties: {}
                    required:
                      - pattern
                    additionalProperties: {}
                  - type: object
                    properties:
                      pattern:
                        type: string
                        enum:
                          - file_transfer
                      transport:
                        anyOf:
                          - type: string
                            enum:
                              - s3
                          - type: string
                            enum:
                              - gcs
                          - type: string
                            enum:
                              - azure_blob
                      directions:
                        type: array
                        items:
                          anyOf:
                            - type: string
                              enum:
                                - buyer_to_seller
                            - type: string
                              enum:
                                - seller_to_buyer
                      vendor:
                        type: object
                        properties:
                          domain:
                            type: string
                            pattern: >-
                              ^[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$
                          brand_id:
                            type: string
                            pattern: ^[a-z0-9_]+$
                          countries:
                            type: array
                            items:
                              type: string
                          industries:
                            type: array
                            items:
                              type: string
                          data_subject_contestation:
                            type: object
                            properties:
                              url:
                                type: string
                                pattern: ^https:\/\/
                              email:
                                type: string
                                format: email
                                pattern: >-
                                  ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
                              languages:
                                type: array
                                items:
                                  type: string
                            additionalProperties: {}
                          brand_kit_override:
                            type: object
                            properties:
                              logo:
                                type: object
                                properties:
                                  asset_type:
                                    type: string
                                    enum:
                                      - image
                                  url:
                                    type: string
                                  width:
                                    type: integer
                                    minimum: 1
                                    maximum: 9007199254740991
                                  height:
                                    type: integer
                                    minimum: 1
                                    maximum: 9007199254740991
                                  file_size_bytes:
                                    type: integer
                                    minimum: 1
                                    maximum: 9007199254740991
                                  pixel_ratio:
                                    type: number
                                    minimum: 0
                                    exclusiveMinimum: true
                                  state_id:
                                    type: string
                                  breakpoint_id:
                                    type: string
                                  focal_point:
                                    type: array
                                    items:
                                      anyOf:
                                        - type: number
                                        - type: number
                                    minItems: 2
                                    maxItems: 2
                                  format:
                                    type: string
                                  alt_text:
                                    type: string
                                  provenance:
                                    type: object
                                    properties:
                                      digital_source_type:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - digital_capture
                                          - type: string
                                            enum:
                                              - digital_creation
                                          - type: string
                                            enum:
                                              - trained_algorithmic_media
                                          - type: string
                                            enum:
                                              - composite_with_trained_algorithmic_media
                                          - type: string
                                            enum:
                                              - algorithmic_media
                                          - type: string
                                            enum:
                                              - composite_capture
                                          - type: string
                                            enum:
                                              - composite_synthetic
                                          - type: string
                                            enum:
                                              - human_edits
                                          - type: string
                                            enum:
                                              - data_driven_media
                                      synthetic_depiction:
                                        type: boolean
                                      ai_tool:
                                        type: object
                                        properties:
                                          name:
                                            type: string
                                          version:
                                            type: string
                                          provider:
                                            type: string
                                        required:
                                          - name
                                        additionalProperties: {}
                                      human_oversight:
                                        anyOf:
                                          - type: string
                                            enum:
                                              - none
                                          - type: string
                                            enum:
                                              - prompt_only
                                          - type: string
                                            enum:
                                              - selected
                                          - type: string
                                            enum:
                                              - edited
                                          - type: string
                                            enum:
                                              - directed
                                      declared_by:
                                        type: object
                                        properties:
                                          agent_url:
                                            type: string
                                          role:
                                            anyOf:
                                              - type: string
                                                enum:
                                                  - creator
                                              - type: string
                                                enum:
                                                  - advertiser
                                              - type: string
                                                enum:
                                                  - agency
                                              - type: string
                                                enum:
                                                  - platform
                                              - type: string
                                                enum:
                                                  - tool
                                        required:
                                          - role
                                        additionalProperties: {}
                                      declared_at:
                                        type: string
                                      created_time:
                                        type: string
                                      c2pa:
                                        type: object
                                        properties:
                                          manifest_url:
                                            type: string
                                        required:
                                          - manifest_url
                                        additionalProperties: {}
                                      embedded_provenance:
                                        type: array
                                        items:
                                          type: object
                                          properties:
                                            method:
                                              anyOf:
                                                - type: string
                                                  enum:
                                                    - manifest_wrapper
                                                - type: string
                                                  enum:
                                                    - provenance_markers
                                            standard:
                                              type: string
                                            provider:
                                              type: string
                                            verify_agent:
                                              type: object
                                              properties:
                                                agent_url:
                                                  type: string
                                                feature_id:
                                                  type: string
                                              required:
                                                - agent_url
                                              additionalProperties: {}
                                            embedded_at:
                                              type: string
                                          required:
                                            - method
                                            - provider
                                          additionalProperties: {}
                                      watermarks:
                                        type: array
                                        items:
                                          type: object
                                          properties:
                                            media_type:
                                              anyOf:
                                                - type: string
                                                  enum:
                                                    - audio
                                                - type: string
                                                  enum:
                                                    - image
                                                - type: string
                                                  enum:
                                                    - video
                                                - type: string
                                                  enum:
                                                    - text
                                            provider:
                                              type: string
                                            verify_agent:
                                              type: object
                                              properties:
                                                agent_url:
                                                  type: string
                                                feature_id:
                                                  type: string
                                              required:
                                                - agent_url
                                              additionalProperties: {}
                                            c2pa_action:
                                              anyOf:
                                                - type: string
                                                  enum:
                                                    - c2pa.watermarked.bound
                                                - type: string
                                                  enum:
                                                    - c2pa.watermarked.unbound
                                            embedded_at:
                                              type: string
                                          required:
                                            - media_type
                                            - provider
                                          additionalProperties: {}
                                      disclosure:
                                        type: object
                                        properties:
                                          required:
                                            type: boolean
                                          jurisdictions:
                                            type: array
                                            items:
                                              type: object
                                              properties:
                                                country:
                                                  type: string
                                                region:
                                                  type: string
                                                regulation:
                                                  type: string
                                                label_text:
                                                  type: string
                                                render_guidance:
                                                  type: object
                                                  properties:
                                                    persistence:
                                                      anyOf:
                                                        - type: string
                                                          enum:
                                                            - continuous
                                                        - type: string
                                                          enum:
                                                            - initial
                                                        - type: string
                                                          enum:
                                                            - flexible
                                                    min_duration_ms:
                                                      type: integer
                                                      minimum: 1
                                                      maximum: 9007199254740991
                                                    positions:
                                                      type: array
                                                      items:
                                                        anyOf:
                                                          - type: string
                                                            enum:
                                                              - prominent
                                                          - type: string
                                                            enum:
                                                              - footer
                                                          - type: string
                                                            enum:
                                                              - audio
                                                          - type: string
                                                            enum:
                                                              - subtitle
                                                          - type: string
                                                            enum:
                                                              - overlay
                                                          - type: string
                                                            enum:
                                                              - end_card
                                                          - type: string
                                                            enum:
                                                              - pre_roll
                                                          - type: string
                                                            enum:
                                                              - companion
                                                    ext:
                                                      type: object
                                                      additionalProperties: {}
                                                  additionalProperties: {}
                                              required:
                                                - country
                                                - regulation
                                              additionalProperties: {}
                                        required:
                                          - required
                                        additionalProperties: {}
                                      verification:
                                        type: array
                                        items:
                                          type: object
                                          properties:
                                            verified_by:
                                              type: string
                                            verified_time:
                                              type: string
                                            result:
                                              anyOf:
                                                - type: string
                                                  enum:
                                                    - authentic
                                                - type: string
                                                  enum:
                                                    - ai_generated
                                                - type: string
                                                  enum:
                                                    - ai_modified
                                                - type: string
                                                  enum:
                                                    - inconclusive
                                            confidence:
                                              type: number
                                              minimum: 0
                                              maximum: 1
                                            details_url:
                                              type: string
                                          required:
                                            - verified_by
                                            - result
                                          additionalProperties: {}
                                      ext:
                                        type: object
                                        additionalProperties: {}
                                    additionalProperties: {}
                                required:
                                  - asset_type
                                  - url
                                  - width
                                  - height
                                additionalProperties: {}
                              colors:
                                type: object
                                properties:
                                  primary:
                                    type: string
                                    pattern: ^#[0-9a-fA-F]{6}$
                                  secondary:
                                    type: string
                                    pattern: ^#[0-9a-fA-F]{6}$
                                  accent:
                                    type: string
                                    pattern: ^#[0-9a-fA-F]{6}$
                                additionalProperties: {}
                              voice:
                                type: string
                              tagline:
                                type: string
                            additionalProperties: {}
                        required:
                          - domain
                        additionalProperties: {}
                    required:
                      - pattern
                    additionalProperties: {}
                  - type: object
                    properties:
                      pattern:
                        type: string
                        enum:
                          - dataset_query
                      vendor:
                        type: object
                        properties:
                          domain:
                            type: string
                            pattern: >-
                              ^[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$
                          brand_id:
                            type: string
                            pattern: ^[a-z0-9_]+$
                          countries:
                            type: array
                            items:
                              type: string
                          industries:
                            type: array
                            items:
                              type: string
                          data_subject_contestation:
                            type: object
                            properties:
                              url:
                                type: string
                                pattern: ^https:\/\/
[...]
